#define STICKY_NOTES_C

#include "main.h"

#include "master_front.xpm"

static sticky_base base;

static GtkWidget *main_window = NULL;
static int main_window_x_pos = -1; /* FIXME: get rid of file variables */
static int main_window_y_pos = -1; /* need to be here atm because of hack in */
static int main_window_x_size = -1; /* save all (as we don't know when */
static int main_window_y_size = -1; /* have moved) */

static int sock_fd = -1;
static struct sockaddr_un sa;

static GtkWidget *save_all_item = NULL;

#if 0
static GtkWidget *list_window = NULL;
static GtkList *global_gtklist = NULL;
#endif

static main_config prefs =
{
 STICKY_MASTER_BUTTON_LOWER, /* button one */
 STICKY_MASTER_BUTTON_RAISE, /* button two */
 GTK_WIN_POS_MOUSE, /* where to position new windows */
 GTK_WINDOW_DIALOG, /* type of Master window */
 GTK_WINDOW_TOPLEVEL, /* type of note windows */
 GTK_WINDOW_DIALOG, /* type of extra windows */
 TRUE, /* auto_placement */
 STICKY_MASTER_QUIT_ASK, /* ask about saving before quit */
};

int sticky_win_x_offset = 0;
int sticky_win_y_offset = 0;


#ifdef DISABLE_CLEVER_SAVE_ALL_SENSITIVE
# define gtk_widget_set_sensitive(x, y) IGNORE_PARAMETERS((x) && (y))
#endif

#ifdef USE_MOVE_RESIZE_SIGNAL
static int sticky_note_store_move_resize(GtkWidget *from, 
                                         int *x, int *y, int width, int height,
                                         sticky_note *note)
{
 note->x_pos = *x;
 note->y_pos = *y;
 note->x_size = width;
 note->y_size = height;

 printf("x = %d, y = %d, w = %d, h = %d.\n",
        note->x_pos, note->y_pos, note->x_size, note->y_size);

 return (FALSE);
}
#endif

#ifndef NDEBUG
static void tmp_print(GtkWidget *from, sticky_note *note)
{
 int tmp = 0;
 int x_tmp = 0;
 int y_tmp = 0;
 int width_tmp;
 int height_tmp;

 IGNORE_PARAMETER(from);
 
 gdk_window_get_origin(note->window->window, &x_tmp, &y_tmp);
 printf("o x = %d, y = %d\n", x_tmp, y_tmp);
  
 gdk_window_get_position(note->window->window, &x_tmp, &y_tmp);
 printf("p x = %d, y = %d\n", x_tmp, y_tmp);
 
 gdk_window_get_geometry(note->window->window,
                         &x_tmp, &y_tmp,
                         &width_tmp, &height_tmp, &tmp);
 printf("g x = %d, y = %d\n", x_tmp, y_tmp);
 printf("g w = %d, h = %d\n", width_tmp, height_tmp);
}
#endif

#ifndef NDEBUG
# define USE_MOVE_RESIZE_SIGNAL_PRINT 1
#endif

static void get_size_pos(GtkWidget *window,
                         int *x_pos, int *y_pos, int *x_size, int *y_size)
{
 int dummy = 0;

 if (!x_pos) x_pos = &dummy;
 if (!y_pos) y_pos = &dummy;
 if (!x_size) x_size = &dummy;
 if (!y_size) y_size = &dummy;
 
 if (GTK_WIDGET_VISIBLE(window))
 {
#if 1 /* def USE_GDK_GET_GEOMETRY */
  /* NOTE: gdk_window_get_geometry gives tx, ty from below... */
  Window root;
  int tx = 0;
  int ty = 0;
  unsigned int tborder_width = 0;
  unsigned int tdepth = 0;

# ifdef USE_MOVE_RESIZE_SIGNAL_PRINT
  printf("x = %d, y = %d, w = %d, h = %d, window = %p.\n",
         *x_pos, *y_pos, *x_size, *y_size, window);
# endif
  
  gdk_window_get_origin(window->window, x_pos, y_pos);
  
  XGetGeometry(((GdkWindowPrivate *)window->window)->xdisplay,
               ((GdkWindowPrivate *)window->window)->xwindow,
               &root, &tx, &ty, x_size, y_size,
               &tborder_width, &tdepth);

  /* uses one global offset, so you might need to have
   * master_win_type == note_win_type */
  *x_pos -= (tx + sticky_win_x_offset + tborder_width);
  *y_pos -= (ty + sticky_win_y_offset + tborder_width);

# ifdef USE_MOVE_RESIZE_SIGNAL_PRINT
  printf("x = %d, y = %d, w = %d, h = %d, tbwid = %u, tdpy = %d, tx = %d, ty = %d.\n",
         *x_pos, *y_pos, *x_size, *y_size, tborder_width, tdepth, tx, ty);
# endif
#else

# ifdef USE_MOVE_RESIZE_SIGNAL_PRINT
  printf("x = %d, y = %d, w = %d, h = %d, window = %p.\n",
         *x_pos, *y_pos, *x_size, *y_size, window);
# endif

  gdk_window_get_geometry(window->window, x_pos, y_pos,
                          x_size, y_size, NULL);

# ifdef USE_MOVE_RESIZE_SIGNAL_PRINT
  printf("x = %d, y = %d, w = %d, h = %d.\n",
         *x_pos, *y_pos, *x_size, *y_size, window);
# endif

#endif
 }
}

static int changed_position_size(GtkWidget *window,
                                 int x_pos, int y_pos,
                                 int x_size, int y_size)
{
 int tmp_x_pos = x_pos;
 int tmp_y_pos = y_pos;
 int tmp_x_size = x_size;
 int tmp_y_size = y_size;

 get_size_pos(window, &x_pos, &y_pos, &x_size, &y_size);
 if ((x_pos == tmp_x_pos) &&
     (y_pos == tmp_y_pos) &&
     (x_size == tmp_x_size) &&
     (y_size == tmp_y_size))
   return (FALSE);
 else
   return (TRUE);
}

static int internal_are_unsaved_stickies(sticky_note *note, va_list va)
{
 int *ret = va_arg(va, int *);
 
 if (GTK_WIDGET_IS_SENSITIVE(note->save_menu_item))
   *ret = TRUE;
 else if (!note->auto_placement && 
          changed_position_size(note->window,
                                note->x_pos, note->y_pos,
                                note->x_size, note->y_size))
   *ret = TRUE;
 
 return (!*ret);
}

static int are_unsaved_stickies(void)
{
 int ret = FALSE;
 
 sticky_note_do_inorder(internal_are_unsaved_stickies, &base, &ret);

 if (!ret && !prefs.auto_placement)
   return (changed_position_size(main_window,
                                 main_window_x_pos, main_window_y_pos,
                                 main_window_x_size, main_window_y_size));
 else
   return (ret);
}

static void set_save_all_sensitive(void)
{
 int current_sens = GTK_WIDGET_IS_SENSITIVE(save_all_item);
 int real_sens = are_unsaved_stickies();

 if (real_sens != current_sens)
   gtk_widget_set_sensitive(save_all_item, real_sens);
}

static void save_note_click(GtkWidget *from, sticky_note *note)
{
 file_io fs;
 const char *chars = gtk_editable_get_chars(GTK_EDITABLE(note->text), 0, -1);
 
 IGNORE_PARAMETER(from);

 if (note->filename &&
     file_write_open(note->filename, STICKY_FILE_NOTE_VERSION, &fs))
 {
  file_section_beg("options", &fs);

  file_put_bitflag("auto_placment", note->auto_placement, &fs);

  file_put_bitflag("hidden",
                   GTK_WIDGET_VISIBLE(note->window) ? FALSE : TRUE, &fs);
  
  file_put_string("name", note->name, &fs);
  
  file_put_unsigned_int("unique_id", note->unique_id, &fs);
  
  file_put_bitflag("using_right", note->using_right, &fs);
  file_put_bitflag("using_scrollbar",
                   GTK_WIDGET_VISIBLE(note->vscrollbar) ? TRUE : FALSE, &fs);

  get_size_pos(note->window, &note->x_pos, &note->y_pos,
               &note->x_size, &note->y_size);
  
  file_put_bitflag("word_wrap", note->word_wrap, &fs);

  file_put_int("x_position", note->x_pos, &fs);
  file_put_int("x_size", note->x_size, &fs);
  file_put_int("y_position", note->y_pos, &fs);
  file_put_int("y_size", note->y_size, &fs);
  
  file_section_end(&fs);
  
  file_put_string("text", chars, &fs);
  
  file_write_close(&fs);
  
  gtk_widget_set_sensitive(note->save_menu_item, FALSE);
  set_save_all_sensitive();
 }
}

static void cut_note_click(GtkWidget *from, sticky_note *note)
{
 IGNORE_PARAMETER(from);
 gtk_editable_cut_clipboard(GTK_EDITABLE(note->text));
}

static void copy_note_click(GtkWidget *from, sticky_note *note)
{
 IGNORE_PARAMETER(from);
 gtk_editable_copy_clipboard(GTK_EDITABLE(note->text));
}

static void paste_note_click(GtkWidget *from, sticky_note *note)
{
 IGNORE_PARAMETER(from);
 gtk_editable_paste_clipboard(GTK_EDITABLE(note->text));
}

static void hide_note_toggle(GtkWidget *from, sticky_note *note)
{
 IGNORE_PARAMETER(from);

 if (GTK_WIDGET_VISIBLE(note->window))
 {
  get_size_pos(note->window, &note->x_pos, &note->y_pos,
               &note->x_size, &note->y_size);
  gtk_widget_hide(note->window);
 }
 else
 {
  if (note->auto_placement)
    gtk_widget_set_uposition(note->window, -1, -1);
  else
    gtk_widget_set_uposition(note->window, note->x_pos, note->y_pos);

  if ((note->x_size < 120) || (note->y_size < 120))
    gtk_widget_set_usize(note->window, 120, 120);
  else
    gtk_widget_set_usize(note->window, note->x_size, note->y_size);

  gtk_widget_show(note->window);
 }
 
 gtk_widget_set_sensitive(note->save_menu_item, TRUE);
 gtk_widget_set_sensitive(save_all_item, TRUE);
}

static void erase_note_click(GtkWidget *from, sticky_note *note)
{
 IGNORE_PARAMETER(from);
 gtk_editable_delete_text(GTK_EDITABLE(note->text), 0, -1);
}

static int internal_write_index_file(sticky_note *note, va_list va)
{
 int *count = va_arg(va, int *);
 file_io *fs = va_arg(va, file_io *);
 char buffer[64];

 sprintf(buffer, "%04d", ++*count);
 
 file_put_unsigned_int(buffer, note->unique_id, fs);
  
 return (TRUE);
}

static void write_index_file(void)
{
 file_io fs;

 if (file_write_open("tmp", STICKY_FILE_MASTER_INDEX_VERSION, &fs))
 {
  unsigned int count = 0;
  
  file_put_int("count", base.count, &fs);

  file_section_beg("data", &fs);
  
  sticky_note_do_cronorder(internal_write_index_file, &base, &count, &fs);

  file_section_end(&fs);

  file_write_close(&fs);
  
  assert(count == base.count);
  rename("tmp", "index");
 }
}

static void write_preferences_file(void)
{
 file_io fs;

 if (file_write_open("tmp", STICKY_FILE_MASTER_PREFERENCES_VERSION, &fs))
 {
  file_put_int("action_on_quit", prefs.action_on_quit, &fs);
  file_put_bitflag("auto_placment", prefs.auto_placement, &fs);

  file_put_int("mouse_one_action", prefs.mouse_one_action, &fs);
  file_put_int("mouse_two_action", prefs.mouse_two_action, &fs);

  file_put_int("pos_type_extra", prefs.win_pos_type, &fs);

  file_put_int("win_type_extra", prefs.extra_win_type, &fs);
  file_put_int("win_type_master", prefs.master_win_type, &fs);
  file_put_int("win_type_note", prefs.note_win_type, &fs);

  get_size_pos(main_window, &main_window_x_pos, &main_window_y_pos,
               &main_window_x_size, &main_window_y_size);
  
  file_put_int("x_position", main_window_x_pos, &fs);
  file_put_int("x_size", main_window_x_size, &fs);
  file_put_int("y_position", main_window_y_pos, &fs);
  file_put_int("y_size", main_window_y_size, &fs);

  file_write_close(&fs);
  rename("tmp", "prefs");
 }
}

static void read_preferences_file(void)
{
 file_io fs;

 if (file_read_open("prefs", &fs))
 {
  int dummy = 0;
  
  prefs.action_on_quit = file_get_int("action_on_quit", &fs);
  prefs.auto_placement = file_get_bitflag("auto_placment", &fs);

  prefs.mouse_one_action = file_get_int("mouse_one_action", &fs);
  prefs.mouse_two_action = file_get_int("mouse_two_action", &fs);

  /* default to the `defaults' above if they are using old data files...
   * <= version 0.4 */
  dummy = file_get_int("pos_type_extra", &fs);
  if (!FILE_IO_CREATED(&fs))
    prefs.win_pos_type = dummy;
  
  dummy = file_get_int("win_type_extra", &fs);
  if (!FILE_IO_CREATED(&fs))
    prefs.extra_win_type = dummy;
  dummy = file_get_int("win_type_master", &fs);
  if (!FILE_IO_CREATED(&fs))
    prefs.master_win_type = dummy;
  dummy = file_get_int("win_type_note", &fs);
  if (!FILE_IO_CREATED(&fs))
    prefs.note_win_type = dummy;
  
  if (!prefs.auto_placement)
  { /* the size is needed for the compare... */
   main_window_x_pos = file_get_int("x_position", &fs);
   main_window_x_size = file_get_int("x_size", &fs);
   main_window_y_pos = file_get_int("y_position", &fs);
   main_window_y_size = file_get_int("y_size", &fs);
  }
  
  gtk_widget_set_uposition(main_window, main_window_x_pos, main_window_y_pos);
  
  file_read_close(&fs);
 }
 else
   gtk_widget_set_uposition(main_window, -1, -1);
}

static void on_finish_event(GtkWidget *from, gpointer nothing)
{
 IGNORE_PARAMETER(nothing);
 
 gtk_grab_remove(from);
 gtk_main_quit();
}

static void destroy_note_click(GtkWidget *from, sticky_note *note)
{
 IGNORE_PARAMETER(from);

 /* FIXME: send message to list_window for non-modal usage */
 unlink(note->filename);
 gtk_editable_delete_text(GTK_EDITABLE(note->text), 0, -1);
 gtk_widget_destroy(note->window);
 write_index_file();
}

static void about_note_click(GtkWidget *from, gpointer nothing)
{
 GtkWidget *window = NULL;
#ifdef USE_GNOME
 const char *authors[] = {
  N_("James Antill."),
  NULL
 };
 
 window = gnome_about_new(_("Sticky notes"), "0.8 of sticky_notes",
                          "(C) 1998 James Antill; Released under the GPL",
                          (char **)authors,
                          _("Postit notes type program."),
                          NULL);

 gtk_widget_show(window);
#else
 GtkWidget *label = NULL;
 GtkWidget *vbox = NULL;
 GtkWidget *button = NULL;
 
 IGNORE_PARAMETER(from && nothing);

 window = gtk_window_new(prefs.extra_win_type);
 gtk_window_position(GTK_WINDOW(window), prefs.win_pos_type);

 gtk_window_set_wmclass(GTK_WINDOW(window), "about_notes", "gtk_note");
 gtk_widget_set_uposition(window, -1, -1);
 gtk_window_set_policy(GTK_WINDOW(window), TRUE, TRUE, TRUE);
 gtk_window_set_title(GTK_WINDOW(window), "About");
#if 0
 gtk_signal_connect(GTK_OBJECT(window),
                    "destroy", GTK_SIGNAL_FUNC(on_finish_event), NULL);
#endif
 
 vbox = gtk_vbox_new(FALSE, 5);
 gtk_container_border_width(GTK_CONTAINER(vbox), 5);
 gtk_container_add(GTK_CONTAINER(window), vbox);
 gtk_widget_show(vbox);
 
 label = gtk_label_new("\n"
                       " This program was initially written by,\n"
                       "  James Antill <james@crazylands.org>. \n"
                       " ... but more recently hacked by,\n"
                       "  AGX <agx@linux.it>. \n"
                       " This program is distributed under the GPL\n"
                       "  (GNU General Public License see www.gnu.org).\n\n");
 gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, TRUE, 0);
 gtk_widget_show(label);
 
 button = gtk_button_new_with_label("Close");
 gtk_widget_show(button);
 gtk_signal_connect_object(GTK_OBJECT(button),
                           "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy),
                           GTK_OBJECT(window));
 gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, TRUE, 0);

 gtk_widget_show(window);
#endif

 IGNORE_PARAMETER(from && nothing);
}

static int internal_get_new_unique(sticky_note *note, va_list va)
{
 unsigned int *unique_id = va_arg(va, unsigned int *);
 
 if (*unique_id < note->unique_id)
   return (FALSE);
 else
   if (*unique_id == note->unique_id)
     ++*unique_id;
 
 return (TRUE);
}

static int sticky_get_new_unique(void)
{
 unsigned int unique_id = 1;

 sticky_note_do_cronorder(internal_get_new_unique, &base, &unique_id);

 return (unique_id);
}

static void sticky_init_filename(sticky_note *note)
{
#ifndef HAVE_ASPRINTF
 char filename[1024];
 
 sprintf(filename, "%04u", note->unique_id);
 
 note->filename = g_strdup(filename);
#else
 asprintf(&note->filename, "%04u", note->unique_id);
#endif 
}

static void sticky_note_init(sticky_note *note)
{
 note->auto_placement = FALSE;
 note->using_right = TRUE;
 note->word_wrap = FALSE;
 
 note->filename = NULL; /* so it won't load */
}

static void create_finnish_new_event(GtkWidget *from, gpointer real_params)
{
 change_event_params *params = real_params;
 sticky_note *note = g_malloc(sizeof(sticky_note));

 note->unique_id = sticky_get_new_unique();
 note->name = g_strdup(gtk_entry_get_text(GTK_ENTRY(params->name_entry)));
 note->x_size = atoi(gtk_entry_get_text(GTK_ENTRY(params->x_size_entry)));
 note->y_size = atoi(gtk_entry_get_text(GTK_ENTRY(params->y_size_entry)));
 note->x_pos = -1;
 note->y_pos = -1;

 sticky_note_init(note);
  
 sticky_note_create(note);

 sticky_init_filename(note);
 
 sticky_note_add(&base, note);
 
 gtk_widget_show(note->window);

 write_index_file();
 save_note_click(NULL, note);
 
 gtk_widget_destroy(from);
}

static void new_main_click(GtkWidget *from, gpointer nothing)
{
 GtkWidget *window = NULL;
 GtkWidget *vbox = NULL;
 GtkWidget *hbox = NULL;
 GtkWidget *entry = NULL;
 GtkWidget *button = NULL;
 change_event_params destroy_params;
 char buffer[256];
 
 IGNORE_PARAMETER(from && nothing);

 destroy_params.note = NULL;
#if 0 /* def USE_GNOME */
 window = gnome_dialog_new("Note list");
 vbox = GNOME_DIALOG(window)->vbox;
 /* FIXME: use gnome modal stuff */
 window = &GNOME_DIALOG(window)->window;
#else
 window = gtk_window_new(prefs.extra_win_type);
 gtk_window_position(GTK_WINDOW(window), prefs.win_pos_type);
 gtk_window_set_title(GTK_WINDOW(window), "Notes list");

 vbox = gtk_vbox_new(FALSE, 5);
 gtk_container_border_width(GTK_CONTAINER(vbox), 5);
 gtk_container_add(GTK_CONTAINER(window), vbox);
#endif
 
 gtk_window_set_wmclass(GTK_WINDOW(window), "create_note", "gtk_note");
 gtk_widget_set_uposition(window, -1, -1);
 gtk_window_set_policy(GTK_WINDOW(window), TRUE, TRUE, TRUE);
 gtk_signal_connect(GTK_OBJECT(window),
                    "destroy", GTK_SIGNAL_FUNC(on_finish_event), NULL);
 
 gtk_widget_show(vbox);

 sprintf(buffer, "Note %d", sticky_get_new_unique());

 MAKE_TEXT_EDITCELL("Note title: ");
 gtk_entry_set_text(GTK_ENTRY(entry), buffer);
 gtk_entry_select_region(GTK_ENTRY(entry), 0, GTK_ENTRY(entry)->text_length);
 gtk_widget_grab_focus(entry);
 destroy_params.name_entry = entry;
 MAKE_TEXT_EDITCELL("Note X size: ");
 gtk_entry_set_text(GTK_ENTRY(entry), "250");
 destroy_params.x_size_entry = entry;
 MAKE_TEXT_EDITCELL("Note Y size: ");
 gtk_entry_set_text(GTK_ENTRY(entry), "200");
 destroy_params.y_size_entry = entry;

 hbox = gtk_hbox_new(FALSE, 5);
 gtk_box_pack_end(GTK_BOX(vbox), hbox, FALSE, TRUE, 0);
 gtk_widget_show(hbox);

 button = gtk_button_new_with_label("Ok");
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);
 gtk_widget_grab_default(button);
 gtk_widget_show(button);
 gtk_signal_connect(GTK_OBJECT(button),
                    "clicked", GTK_SIGNAL_FUNC(create_finnish_new_event),
                    (gpointer) &destroy_params);
 gtk_signal_connect_object(GTK_OBJECT(button),
                           "destroy", GTK_SIGNAL_FUNC(gtk_widget_destroy),
                           GTK_OBJECT(window));
 button = gtk_button_new_with_label("Cancel");
 gtk_widget_show(button);
 gtk_signal_connect_object(GTK_OBJECT(button),
                           "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy),
                           GTK_OBJECT(window));
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);

 gtk_widget_show(window);
 gtk_grab_add(window);
 gtk_main();
}

static void vert_scrollbar_note_toggle(GtkWidget *from, sticky_note *note)
{   
 IGNORE_PARAMETER(from);

 if (GTK_WIDGET_VISIBLE(note->vscrollbar))
   gtk_widget_hide(note->vscrollbar);
 else
   gtk_widget_show(note->vscrollbar);
}

static void change_finnish_note_pref_event(GtkWidget *from,
                                           gpointer real_params)
{
 change_event_params *params = real_params;
 sticky_note *note = params->note;
 
 note->name = g_strdup(gtk_entry_get_text(GTK_ENTRY(params->name_entry)));

 note->auto_placement = params->auto_placement;

 if (params->word_wrap != note->word_wrap)
   gtk_text_set_word_wrap(GTK_TEXT(note->text),
                          note->word_wrap = params->word_wrap);
 if (params->using_right != note->using_right)
   gtk_box_reorder_child(GTK_BOX(note->hbox), note->vscrollbar,
                         note->using_right = params->using_right);
 
 if ((params->using_scrollbar && !GTK_WIDGET_VISIBLE(note->vscrollbar)) ||
     (!params->using_scrollbar && GTK_WIDGET_VISIBLE(note->vscrollbar)))
   vert_scrollbar_note_toggle(from, note);
   
 gtk_window_set_title(GTK_WINDOW(note->window), note->name);

 sticky_note_del(note);
 sticky_note_add(&base, note);
 
 gtk_widget_set_sensitive(note->save_menu_item, TRUE);
 gtk_widget_set_sensitive(save_all_item, TRUE);
 
 gtk_widget_destroy(from);
}

static void change_on_toggle_note_pref_event(GtkWidget *from,
                                             gpointer real_params)
{
 change_event_params *params = real_params;

 IGNORE_PARAMETER(from);

 params->using_scrollbar = TRUE;
}

static void change_left_toggle_note_pref_event(GtkWidget *from,
                                               gpointer real_params)
{
 change_event_params *params = real_params;

 IGNORE_PARAMETER(from);
 
 params->using_right = FALSE;
}

static void change_off_toggle_note_pref_event(GtkWidget *from,
                                              gpointer real_params)
{
 change_event_params *params = real_params;

 IGNORE_PARAMETER(from);

 params->using_scrollbar = FALSE;
}

static void change_right_toggle_note_pref_event(GtkWidget *from,
                                                gpointer real_params)
{
 change_event_params *params = real_params;

 IGNORE_PARAMETER(from);

 params->using_right = TRUE;
}

static void change_auto_toggle_note_pref_event(GtkWidget *from,
                                               gpointer real_params)
{
 change_event_params *params = real_params;

 IGNORE_PARAMETER(from);
 
 params->auto_placement = TRUE;
}

static void change_saved_toggle_note_pref_event(GtkWidget *from,
                                                gpointer real_params)
{
 change_event_params *params = real_params;

 IGNORE_PARAMETER(from);
 
 params->auto_placement = FALSE;
}

static void change_word_wrap_toggle_note_pref_event(GtkWidget *from,
                                                    gpointer real_params)
{
 change_event_params *params = real_params;

 IGNORE_PARAMETER(from);
 
 params->word_wrap = TRUE;
}

static void change_char_wrap_toggle_note_pref_event(GtkWidget *from,
                                                    gpointer real_params)
{
 change_event_params *params = real_params;

 IGNORE_PARAMETER(from);
 
 params->word_wrap = FALSE;
}

static void preferences_note_click(GtkWidget *from, sticky_note *note)
{
 GtkWidget *window = NULL;
 GtkWidget *vbox = NULL;
 GtkWidget *hbox = NULL;
 GtkWidget *entry = NULL;
 GtkWidget *button = NULL;
 change_event_params destroy_params;

 IGNORE_PARAMETER(from);

 destroy_params.note = note;
 
 window = gtk_window_new(prefs.extra_win_type);
 gtk_window_position(GTK_WINDOW(window), prefs.win_pos_type);

 gtk_window_set_wmclass(GTK_WINDOW(window), "change_note", "gtk_note");
 gtk_widget_set_uposition(window, -1, -1);
 gtk_window_set_policy(GTK_WINDOW(window), TRUE, TRUE, TRUE);
 gtk_window_set_title(GTK_WINDOW(window), "Note Preferences");
 gtk_signal_connect(GTK_OBJECT(window),
                    "destroy", GTK_SIGNAL_FUNC(on_finish_event), NULL);
 
 vbox = gtk_vbox_new(FALSE, 0);
 gtk_container_border_width(GTK_CONTAINER(vbox), 0);
 gtk_container_add(GTK_CONTAINER(window), vbox);
 gtk_box_set_homogeneous(GTK_BOX(vbox), TRUE);
 gtk_widget_show(vbox);

 hbox = gtk_hbox_new(FALSE, 0);
 gtk_box_pack_end(GTK_BOX(vbox), hbox, FALSE, TRUE, 0);
 gtk_widget_show(hbox);

 button = gtk_button_new_with_label("Ok");
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);
 gtk_widget_grab_default(button);
 gtk_widget_show(button);
 gtk_signal_connect(GTK_OBJECT(button),
                    "clicked", GTK_SIGNAL_FUNC(change_finnish_note_pref_event),
                    (gpointer) &destroy_params);
 gtk_signal_connect_object(GTK_OBJECT(button),
                           "destroy", GTK_SIGNAL_FUNC(gtk_widget_destroy),
                           GTK_OBJECT(window));
 button = gtk_button_new_with_label("Cancel");
 gtk_widget_show(button);
 gtk_signal_connect_object(GTK_OBJECT(button),
                           "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy),
                           GTK_OBJECT(window));
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 
 MAKE_TEXT_EDITCELL("Note title: ");
 gtk_entry_set_text(GTK_ENTRY(entry), note->name);
 gtk_entry_select_region(GTK_ENTRY(entry), 0, GTK_ENTRY(entry)->text_length);
 gtk_widget_grab_focus(entry);
 destroy_params.name_entry = entry;

 hbox = gtk_hbox_new(FALSE, 5);
 gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, TRUE, 0);
 gtk_widget_show(hbox);

 destroy_params.auto_placement = note->auto_placement;
  
 button = gtk_radio_button_new_with_label(NULL, "Auto placement");
 gtk_signal_connect(GTK_OBJECT(button), "clicked",
                    GTK_SIGNAL_FUNC(change_auto_toggle_note_pref_event),
                    &destroy_params);
 if (destroy_params.auto_placement)
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(button), TRUE);
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 gtk_widget_show(button);
 
 button = gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(button),
                                                      "Saved placement");
 gtk_signal_connect(GTK_OBJECT(button), "clicked",
                    GTK_SIGNAL_FUNC(change_saved_toggle_note_pref_event),
                    &destroy_params);
 if (!destroy_params.auto_placement)
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(button), TRUE);
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 gtk_widget_show(button);

 hbox = gtk_hbox_new(FALSE, 5);
 gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, TRUE, 0);
 gtk_widget_show(hbox);

 destroy_params.word_wrap = note->word_wrap;
  
 button = gtk_radio_button_new_with_label(NULL, "Word wrapping");
 gtk_signal_connect(GTK_OBJECT(button), "clicked",
                    GTK_SIGNAL_FUNC(change_word_wrap_toggle_note_pref_event),
                    &destroy_params);
 if (destroy_params.word_wrap)
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(button), TRUE);
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 gtk_widget_show(button);
 
 button = gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(button),
                                                      "Character wrapping");
 gtk_signal_connect(GTK_OBJECT(button), "clicked",
                    GTK_SIGNAL_FUNC(change_char_wrap_toggle_note_pref_event),
                    &destroy_params);
 if (!destroy_params.word_wrap)
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(button), TRUE);
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 gtk_widget_show(button);

 destroy_params.using_right = note->using_right;
 if (GTK_WIDGET_VISIBLE(note->vscrollbar))
   destroy_params.using_scrollbar = TRUE;
 else
   destroy_params.using_scrollbar = FALSE;
 
 button = gtk_radio_button_new_with_label(NULL, "Scrollbar on");
 gtk_signal_connect(GTK_OBJECT(button), "clicked",
                    GTK_SIGNAL_FUNC(change_on_toggle_note_pref_event),
                    &destroy_params);
 if (destroy_params.using_scrollbar)
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(button), TRUE);
 gtk_box_pack_start(GTK_BOX(vbox), button, TRUE, TRUE, 0);
 gtk_widget_show(button);

 button = gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(button),
                                                      "Scrollbar off");
 gtk_signal_connect(GTK_OBJECT(button), "clicked",
                    GTK_SIGNAL_FUNC(change_off_toggle_note_pref_event),
                    &destroy_params);
 if (!destroy_params.using_scrollbar)
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(button), TRUE);
 gtk_box_pack_end(GTK_BOX(vbox), button, TRUE, TRUE, 0);
 gtk_widget_show(button);

 hbox = gtk_hbox_new(FALSE, 5);
 gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, TRUE, 0);
 gtk_widget_show(hbox);

 button = gtk_radio_button_new_with_label(NULL, "Scrollbar left");
 gtk_signal_connect(GTK_OBJECT(button), "clicked",
                    GTK_SIGNAL_FUNC(change_left_toggle_note_pref_event),
                    &destroy_params);
 if (!note->using_right)
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(button), TRUE);
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 gtk_widget_show(button);
 
 button = gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(button),
                                                      "Scrollbar right");
 gtk_signal_connect(GTK_OBJECT(button), "clicked",
                    GTK_SIGNAL_FUNC(change_right_toggle_note_pref_event),
                    &destroy_params);
 if (note->using_right)
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(button), TRUE);
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 gtk_widget_show(button);

 gtk_widget_show(window);
 gtk_grab_add(window);
 gtk_main();
}

static void change_finnish_main_pref_event(GtkWidget *from,
                                           gpointer real_params)
{
 main_config *params = real_params;
 
 prefs.mouse_one_action = params->mouse_one_action;
 prefs.mouse_two_action = params->mouse_two_action;

 prefs.win_pos_type = params->win_pos_type;
 
 prefs.extra_win_type = params->extra_win_type;
 prefs.master_win_type = params->master_win_type;
 prefs.note_win_type = params->note_win_type;
 
 prefs.auto_placement = params->auto_placement;
 prefs.action_on_quit = params->action_on_quit;

 write_preferences_file();
 
 gtk_widget_destroy(from);
}

static void change_auto_toggle_main_pref_event(GtkWidget *from,
                                               gpointer real_params)
{
 main_config *params = real_params;

 IGNORE_PARAMETER(from);
 
 params->auto_placement = TRUE;
}

static void change_saved_toggle_main_pref_event(GtkWidget *from,
                                                gpointer real_params)
{
 main_config *params = real_params;

 IGNORE_PARAMETER(from);

 params->auto_placement = FALSE;
}

static void change_mouse_raise_toggle_main_pref_event(GtkWidget *from,
                                                      gpointer real_params)
{
 int *param = real_params;
 
 IGNORE_PARAMETER(from);

 *param = STICKY_MASTER_BUTTON_RAISE;
}

static void change_mouse_lower_toggle_main_pref_event(GtkWidget *from,
                                                      gpointer real_params)
{
 int *param = real_params;
 
 IGNORE_PARAMETER(from);

 *param = STICKY_MASTER_BUTTON_LOWER;
}

static void change_mouse_show_toggle_main_pref_event(GtkWidget *from,
                                                     gpointer real_params)
{
 int *param = real_params;
 
 IGNORE_PARAMETER(from);

 *param = STICKY_MASTER_BUTTON_SHOW;
}

static void change_win_type_dialog_pref_event(GtkWidget *from,
                                              gpointer real_params)
{
 int *param = real_params;
 
 IGNORE_PARAMETER(from);

 *param = GTK_WINDOW_DIALOG;
}

static void change_win_type_toplevel_pref_event(GtkWidget *from,
                                                gpointer real_params)
{
 int *param = real_params;
 
 IGNORE_PARAMETER(from);

 *param = GTK_WINDOW_TOPLEVEL;
}

static void change_win_pos_mouse_pref_event(GtkWidget *from,
                                            gpointer real_params)
{
 int *param = real_params;
 
 IGNORE_PARAMETER(from);

 *param = GTK_WIN_POS_MOUSE;
}

static void change_win_pos_center_pref_event(GtkWidget *from,
                                             gpointer real_params)
{
 int *param = real_params;
 
 IGNORE_PARAMETER(from);

 *param = GTK_WIN_POS_CENTER;
}

static void change_win_pos_none_pref_event(GtkWidget *from,
                                           gpointer real_params)
{
 int *param = real_params;
 
 IGNORE_PARAMETER(from);

 *param = GTK_WIN_POS_NONE;
}

static void change_mouse_hide_toggle_main_pref_event(GtkWidget *from,
                                                      gpointer real_params)
{
 int *param = real_params;
 
 IGNORE_PARAMETER(from);

 *param = STICKY_MASTER_BUTTON_HIDE;
}

static void change_quit_quit_toggle_main_pref_event(GtkWidget *from,
                                                    gpointer real_params)
{
 main_config *params = real_params;

 IGNORE_PARAMETER(from);
 
 params->action_on_quit = STICKY_MASTER_QUIT_QUIT;
}

static void change_quit_save_toggle_main_pref_event(GtkWidget *from,
                                                    gpointer real_params)
{
 main_config *params = real_params;

 IGNORE_PARAMETER(from);
 
 params->action_on_quit = STICKY_MASTER_QUIT_SAVE;
}

static void change_quit_ask_toggle_main_pref_event(GtkWidget *from,
                                                    gpointer real_params)
{
 main_config *params = real_params;

 IGNORE_PARAMETER(from);

 params->action_on_quit = STICKY_MASTER_QUIT_ASK;
}

static void preferences_main_click(GtkWidget *from, gpointer nothing)
{
 GtkWidget *window = NULL;
 GtkWidget *vbox = NULL;
 GtkWidget *hbox = NULL;
 GtkWidget *label = NULL;
 GtkWidget *button = NULL;
 main_config destroy_params;

 IGNORE_PARAMETER(from && nothing);

 window = gtk_window_new(prefs.extra_win_type);
 gtk_window_position(GTK_WINDOW(window), prefs.win_pos_type);
 
 gtk_window_set_wmclass(GTK_WINDOW(window), "change_main", "gtk_note");
 gtk_widget_set_uposition(window, -1, -1);
 gtk_window_set_policy(GTK_WINDOW(window), TRUE, TRUE, TRUE);
 gtk_window_set_title(GTK_WINDOW(window), "Main Preferences");
 gtk_signal_connect(GTK_OBJECT(window),
                    "destroy", GTK_SIGNAL_FUNC(on_finish_event), NULL);
 
 vbox = gtk_vbox_new(FALSE, 5);
 gtk_container_border_width(GTK_CONTAINER(vbox), 5);
 gtk_container_add(GTK_CONTAINER(window), vbox);
 gtk_widget_show(vbox);

 hbox = gtk_hbox_new(FALSE, 5);
 gtk_box_pack_end(GTK_BOX(vbox), hbox, FALSE, TRUE, 0);
 gtk_widget_show(hbox);

 button = gtk_button_new_with_label("Ok");
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);
 gtk_widget_grab_default(button);
 gtk_widget_show(button);
 gtk_signal_connect(GTK_OBJECT(button),
                    "clicked", GTK_SIGNAL_FUNC(change_finnish_main_pref_event),
                    (gpointer) &destroy_params);
 gtk_signal_connect_object(GTK_OBJECT(button),
                           "destroy", GTK_SIGNAL_FUNC(gtk_widget_destroy),
                           GTK_OBJECT(window));
 button = gtk_button_new_with_label("Cancel");
 gtk_widget_show(button);
 gtk_signal_connect_object(GTK_OBJECT(button),
                           "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy),
                           GTK_OBJECT(window));
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);

 label = gtk_label_new(" Note placement");
 gtk_box_pack_start(GTK_BOX(vbox), label, TRUE, TRUE, 0);
 gtk_widget_show(label);
 
 hbox = gtk_hbox_new(FALSE, 5);
 gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, TRUE, 0);
 gtk_widget_show(hbox);

 destroy_params.auto_placement = prefs.auto_placement;
 
 button = gtk_radio_button_new_with_label(NULL, "Auto");
 gtk_signal_connect(GTK_OBJECT(button), "clicked",
                    GTK_SIGNAL_FUNC(change_auto_toggle_main_pref_event),
                    &destroy_params);
 if (destroy_params.auto_placement)
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(button), TRUE);
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 gtk_widget_show(button);
 
 button = gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(button),
                                                      "Saved");
 gtk_signal_connect(GTK_OBJECT(button), "clicked",
                    GTK_SIGNAL_FUNC(change_saved_toggle_main_pref_event),
                    &destroy_params);
 if (!destroy_params.auto_placement)
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(button), TRUE);
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 gtk_widget_show(button);

 label = gtk_label_new(" Helper dialogs placement");
 gtk_box_pack_start(GTK_BOX(vbox), label, TRUE, TRUE, 0);
 gtk_widget_show(label);
 
 hbox = gtk_hbox_new(FALSE, 5);
 gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, TRUE, 0);
 gtk_widget_show(hbox);

 destroy_params.win_pos_type = prefs.win_pos_type;
 
 button = gtk_radio_button_new_with_label(NULL, "Mouse");
 gtk_signal_connect(GTK_OBJECT(button), "clicked",
                    GTK_SIGNAL_FUNC(change_win_pos_mouse_pref_event),
                    &destroy_params.win_pos_type);
 if (destroy_params.win_pos_type == GTK_WIN_POS_MOUSE)
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(button), TRUE);
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 gtk_widget_show(button);
 
 button = gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(button),
                                                      "Center");
 gtk_signal_connect(GTK_OBJECT(button), "clicked",
                    GTK_SIGNAL_FUNC(change_win_pos_center_pref_event),
                    &destroy_params.win_pos_type);
 if (destroy_params.win_pos_type == GTK_WIN_POS_CENTER)
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(button), TRUE);
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 gtk_widget_show(button);
 
 button = gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(button),
                                                      "None");
 gtk_signal_connect(GTK_OBJECT(button), "clicked",
                    GTK_SIGNAL_FUNC(change_win_pos_none_pref_event),
                    &destroy_params.win_pos_type);
 if (destroy_params.win_pos_type == GTK_WIN_POS_NONE)
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(button), TRUE);
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 gtk_widget_show(button);

 label = gtk_label_new(" Main window type");
 gtk_box_pack_start(GTK_BOX(vbox), label, TRUE, TRUE, 0);
 gtk_widget_show(label);
 
 hbox = gtk_hbox_new(FALSE, 5);
 gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, TRUE, 0);
 gtk_widget_show(hbox);

 destroy_params.master_win_type = prefs.master_win_type;
 
 button = gtk_radio_button_new_with_label(NULL, "Dialog");
 gtk_signal_connect(GTK_OBJECT(button), "clicked",
                    GTK_SIGNAL_FUNC(change_win_type_dialog_pref_event),
                    &destroy_params.master_win_type);
 if (destroy_params.master_win_type == GTK_WINDOW_DIALOG)
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(button), TRUE);
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 gtk_widget_show(button);
 
 button = gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(button),
                                                      "Normal");
 gtk_signal_connect(GTK_OBJECT(button), "clicked",
                    GTK_SIGNAL_FUNC(change_win_type_toplevel_pref_event),
                    &destroy_params.master_win_type);
 if (destroy_params.master_win_type == GTK_WINDOW_TOPLEVEL)
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(button), TRUE);
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 gtk_widget_show(button);
 
 label = gtk_label_new(" Notes window type");
 gtk_box_pack_start(GTK_BOX(vbox), label, TRUE, TRUE, 0);
 gtk_widget_show(label);
 
 hbox = gtk_hbox_new(FALSE, 5);
 gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, TRUE, 0);
 gtk_widget_show(hbox);

 destroy_params.note_win_type = prefs.note_win_type;
 
 button = gtk_radio_button_new_with_label(NULL, "Dialog");
 gtk_signal_connect(GTK_OBJECT(button), "clicked",
                    GTK_SIGNAL_FUNC(change_win_type_dialog_pref_event),
                    &destroy_params.note_win_type);
 if (destroy_params.note_win_type == GTK_WINDOW_DIALOG)
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(button), TRUE);
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 gtk_widget_show(button);
 
 button = gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(button),
                                                      "Normal");
 gtk_signal_connect(GTK_OBJECT(button), "clicked",
                    GTK_SIGNAL_FUNC(change_win_type_toplevel_pref_event),
                    &destroy_params.note_win_type);
 if (destroy_params.note_win_type == GTK_WINDOW_TOPLEVEL)
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(button), TRUE);
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 gtk_widget_show(button);
 
 label = gtk_label_new(" Helper window types");
 gtk_box_pack_start(GTK_BOX(vbox), label, TRUE, TRUE, 0);
 gtk_widget_show(label);
 
 hbox = gtk_hbox_new(FALSE, 5);
 gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, TRUE, 0);
 gtk_widget_show(hbox);

 destroy_params.extra_win_type = prefs.extra_win_type;
 
 button = gtk_radio_button_new_with_label(NULL, "Dialog");
 gtk_signal_connect(GTK_OBJECT(button), "clicked",
                    GTK_SIGNAL_FUNC(change_win_type_dialog_pref_event),
                    &destroy_params.extra_win_type);
 if (destroy_params.extra_win_type == GTK_WINDOW_DIALOG)
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(button), TRUE);
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 gtk_widget_show(button);
 
 button = gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(button),
                                                      "Normal");
 gtk_signal_connect(GTK_OBJECT(button), "clicked",
                    GTK_SIGNAL_FUNC(change_win_type_toplevel_pref_event),
                    &destroy_params.extra_win_type);
 if (destroy_params.extra_win_type == GTK_WINDOW_TOPLEVEL)
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(button), TRUE);
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 gtk_widget_show(button);
 
 label = gtk_label_new(" Button one action");
 gtk_box_pack_start(GTK_BOX(vbox), label, TRUE, TRUE, 0);
 gtk_widget_show(label);
 
 hbox = gtk_hbox_new(FALSE, 5);
 gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, TRUE, 0);
 gtk_widget_show(hbox);

 destroy_params.mouse_one_action = prefs.mouse_one_action;

 button = gtk_radio_button_new_with_label(NULL, "Raise");
 gtk_signal_connect(GTK_OBJECT(button), "clicked",
                    GTK_SIGNAL_FUNC(change_mouse_raise_toggle_main_pref_event),
                    &destroy_params.mouse_one_action);
 if (destroy_params.mouse_one_action == STICKY_MASTER_BUTTON_RAISE)
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(button), TRUE);
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 gtk_widget_show(button);
 
 button = gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(button),
                                                      "Lower");
 gtk_signal_connect(GTK_OBJECT(button), "clicked",
                    GTK_SIGNAL_FUNC(change_mouse_lower_toggle_main_pref_event),
                    &destroy_params.mouse_one_action);
 if (destroy_params.mouse_one_action == STICKY_MASTER_BUTTON_LOWER)
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(button), TRUE);
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 gtk_widget_show(button);

 button = gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(button),
                                                      "Show");
 gtk_signal_connect(GTK_OBJECT(button), "clicked",
                    GTK_SIGNAL_FUNC(change_mouse_show_toggle_main_pref_event),
                    &destroy_params.mouse_one_action);
 if (destroy_params.mouse_one_action == STICKY_MASTER_BUTTON_SHOW)
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(button), TRUE);
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 gtk_widget_show(button);
 
 button = gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(button),
                                                      "Hide");
 gtk_signal_connect(GTK_OBJECT(button), "clicked",
                    GTK_SIGNAL_FUNC(change_mouse_hide_toggle_main_pref_event),
                    &destroy_params.mouse_one_action);
 if (destroy_params.mouse_one_action == STICKY_MASTER_BUTTON_HIDE)
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(button), TRUE);
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 gtk_widget_show(button);

 label = gtk_label_new(" Button two action");
 gtk_box_pack_start(GTK_BOX(vbox), label, TRUE, TRUE, 0);
 gtk_widget_show(label);
 
 hbox = gtk_hbox_new(FALSE, 5);
 gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, TRUE, 0);
 gtk_widget_show(hbox);

 destroy_params.mouse_two_action = prefs.mouse_two_action;

 button = gtk_radio_button_new_with_label(NULL, "Raise");
 gtk_signal_connect(GTK_OBJECT(button), "clicked",
                    GTK_SIGNAL_FUNC(change_mouse_raise_toggle_main_pref_event),
                    &destroy_params.mouse_two_action);
 if (destroy_params.mouse_two_action == STICKY_MASTER_BUTTON_RAISE)
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(button), TRUE);
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 gtk_widget_show(button);
 
 button = gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(button),
                                                      "Lower");
 gtk_signal_connect(GTK_OBJECT(button), "clicked",
                    GTK_SIGNAL_FUNC(change_mouse_lower_toggle_main_pref_event),
                    &destroy_params.mouse_two_action);
 if (destroy_params.mouse_two_action == STICKY_MASTER_BUTTON_LOWER)
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(button), TRUE);
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 gtk_widget_show(button);

 button = gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(button),
                                                      "Show");
 gtk_signal_connect(GTK_OBJECT(button), "clicked",
                    GTK_SIGNAL_FUNC(change_mouse_show_toggle_main_pref_event),
                    &destroy_params.mouse_two_action);
 if (destroy_params.mouse_two_action == STICKY_MASTER_BUTTON_SHOW)
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(button), TRUE);
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 gtk_widget_show(button);
 
 button = gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(button),
                                                      "Hide");
 gtk_signal_connect(GTK_OBJECT(button), "clicked",
                    GTK_SIGNAL_FUNC(change_mouse_hide_toggle_main_pref_event),
                    &destroy_params.mouse_two_action);
 if (destroy_params.mouse_two_action == STICKY_MASTER_BUTTON_HIDE)
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(button), TRUE);
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 gtk_widget_show(button);

 label = gtk_label_new(" On quit");
 gtk_box_pack_start(GTK_BOX(vbox), label, TRUE, TRUE, 0);
 gtk_widget_show(label);

 hbox = gtk_hbox_new(FALSE, 5);
 gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, TRUE, 0);
 gtk_widget_show(hbox);

 destroy_params.action_on_quit = prefs.action_on_quit;
 
 button = gtk_radio_button_new_with_label(NULL, "Nothing");
 gtk_signal_connect(GTK_OBJECT(button), "clicked",
                    GTK_SIGNAL_FUNC(change_quit_quit_toggle_main_pref_event),
                    &destroy_params);
 if (destroy_params.action_on_quit == STICKY_MASTER_QUIT_QUIT)
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(button), TRUE);
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 gtk_widget_show(button);
 
 button = gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(button),
                                                      "Save all");
 gtk_signal_connect(GTK_OBJECT(button), "clicked",
                    GTK_SIGNAL_FUNC(change_quit_save_toggle_main_pref_event),
                    &destroy_params);
 if (destroy_params.action_on_quit == STICKY_MASTER_QUIT_SAVE)
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(button), TRUE);
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 gtk_widget_show(button);

 button = gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(button),
                                                      "Ask");
 gtk_signal_connect(GTK_OBJECT(button), "clicked",
                    GTK_SIGNAL_FUNC(change_quit_ask_toggle_main_pref_event),
                    &destroy_params);
 if (destroy_params.action_on_quit == STICKY_MASTER_QUIT_ASK)
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(button), TRUE);
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 gtk_widget_show(button);

 gtk_widget_show(window);
 gtk_grab_add(window);
 gtk_main();
}

static void internal_show_hide(gpointer data, gpointer user_data)
{
  sticky_note *note = gtk_object_get_user_data(GTK_OBJECT(data));
  int *ref_visible = user_data;
  int visible = *ref_visible;
  
  assert(note);

  if (note &&
      ((!GTK_WIDGET_VISIBLE(note->window) && !visible) ||
       (GTK_WIDGET_VISIBLE(note->window) && visible)))
    hide_note_toggle(NULL, note);
}

static void hide_list_click(GtkWidget *gtklist, gpointer nothing)
{
 int visible = TRUE;
 
 IGNORE_PARAMETER(nothing);
 
 g_list_foreach(GTK_LIST(gtklist)->selection, internal_show_hide, &visible);
}

static void show_list_click(GtkWidget *gtklist, gpointer nothing)
{
 int visible = FALSE;
 
 IGNORE_PARAMETER(nothing);
 
 g_list_foreach(GTK_LIST(gtklist)->selection, internal_show_hide, &visible);
}

static void internal_raise_lower_selection(gpointer data, gpointer user_data)
{
 sticky_note *note = gtk_object_get_user_data(GTK_OBJECT(data));
 int *ref_do_raise = user_data;
 int do_raise = *ref_do_raise;

 if (note && GTK_WIDGET_VISIBLE(note->window))
   if (do_raise)
     gdk_window_raise(note->window->window);
   else
     gdk_window_lower(note->window->window);
}

static void raise_list_click(GtkWidget *gtklist, gpointer nothing)
{
 int do_raise = TRUE;
 
 IGNORE_PARAMETER(nothing);
 
 g_list_foreach(GTK_LIST(gtklist)->selection,
                internal_raise_lower_selection, &do_raise);
}

static void lower_list_click(GtkWidget *gtklist, gpointer nothing)
{
 int do_raise = FALSE;

 IGNORE_PARAMETER(nothing);
 
 g_list_foreach(GTK_LIST(gtklist)->selection,
                internal_raise_lower_selection, &do_raise);
}

static void change_list_selection(GtkWidget *gtklist, gpointer nothing)
{
 raise_list_click(gtklist, nothing);
}

static int internal_add_sticky_to_list(sticky_note *scan, va_list va)
{
 GtkWidget *gtklist = va_arg(va, GtkWidget *);
 GtkWidget *list_item = gtk_list_item_new();
 GtkWidget *label = gtk_label_new(scan->name);
 
 gtk_container_add(GTK_CONTAINER(list_item), label);
 gtk_widget_show(label);
 
 gtk_container_add(GTK_CONTAINER(gtklist), list_item);
 gtk_widget_show(list_item); 

 gtk_object_set_user_data(GTK_OBJECT(list_item), scan);

 return (TRUE);
}

static void internal_list_main_click(GtkWidget *from, gpointer nothing,
                                     int hidden_only)
{
 GtkWidget *list_window = NULL; 
 GtkWidget *gtklist = NULL;
 GtkWidget *vbox = NULL;
 GtkWidget *hbox = NULL;
 GtkWidget *button = NULL;
 GtkWidget *scrolled_window = NULL;
 
 IGNORE_PARAMETER(from && nothing);

 if (list_window)
   return;
 
 list_window = gtk_window_new(prefs.extra_win_type);
 gtk_window_position(GTK_WINDOW(list_window), prefs.win_pos_type);

 gtk_window_set_wmclass(GTK_WINDOW(list_window), "list_notes", "gtk_note");
 gtk_widget_set_uposition(list_window, -1, -1);
 gtk_window_set_policy(GTK_WINDOW(list_window), TRUE, TRUE, TRUE);
 gtk_window_set_title(GTK_WINDOW(list_window), "Notes list");
 /* gtk_signal_connect(GTK_OBJECT(window),
                    "destroy", GTK_SIGNAL_FUNC(gtk_window_deleted),
                    &list_window);
 */
 gtk_signal_connect(GTK_OBJECT(list_window),
                    "destroy", GTK_SIGNAL_FUNC(gtk_main_quit), NULL);
  
 vbox = gtk_vbox_new(FALSE, 5);
 gtk_container_border_width(GTK_CONTAINER(vbox), 5);
 gtk_container_add(GTK_CONTAINER(list_window), vbox);
 gtk_widget_show(vbox);           

 scrolled_window = gtk_scrolled_window_new(NULL, NULL);
 gtk_widget_set_usize(scrolled_window, 250, 150);
 gtk_box_pack_start(GTK_BOX(vbox), scrolled_window, FALSE, FALSE, 0);
 gtk_widget_show(scrolled_window);           

 gtklist = gtk_list_new();
 gtk_list_set_selection_mode(GTK_LIST(gtklist), GTK_SELECTION_MULTIPLE);
 gtk_container_add(GTK_CONTAINER(scrolled_window), gtklist);
 gtk_widget_show(gtklist);
 gtk_signal_connect(GTK_OBJECT(gtklist),
                    "selection_changed",
                    GTK_SIGNAL_FUNC(change_list_selection),
                    NULL);

 if (hidden_only)
   sticky_note_do_inorder_hidden(internal_add_sticky_to_list, &base, gtklist);
 else
   sticky_note_do_inorder(internal_add_sticky_to_list, &base, gtklist);
 
 hbox = gtk_hbox_new(FALSE, 8);
 gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, TRUE, 0);
 gtk_widget_show(hbox);

 button = gtk_button_new_with_label("Show");
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 gtk_widget_show(button);
 gtk_signal_connect_object(GTK_OBJECT(button),
                           "clicked", GTK_SIGNAL_FUNC(show_list_click),
                           GTK_OBJECT(gtklist));

 button = gtk_button_new_with_label("Hide");
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 gtk_widget_show(button);
 gtk_signal_connect_object(GTK_OBJECT(button),
                           "clicked", GTK_SIGNAL_FUNC(hide_list_click),
                           GTK_OBJECT(gtklist));

 hbox = gtk_hbox_new(FALSE, 8);
 gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, TRUE, 0);
 gtk_widget_show(hbox);

 button = gtk_button_new_with_label("Raise");
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 gtk_widget_show(button);
 gtk_signal_connect_object(GTK_OBJECT(button),
                           "clicked", GTK_SIGNAL_FUNC(raise_list_click),
                           GTK_OBJECT(gtklist));

 button = gtk_button_new_with_label("Lower");
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 gtk_widget_show(button);
 gtk_signal_connect_object(GTK_OBJECT(button),
                           "clicked", GTK_SIGNAL_FUNC(lower_list_click),
                           GTK_OBJECT(gtklist));

 hbox = gtk_hbox_new(FALSE, 8);
 gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, TRUE, 0);
 gtk_widget_show(hbox);

 button = gtk_button_new_with_label("Close");
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);
 gtk_widget_grab_default(button);
 gtk_widget_show(button);
 gtk_signal_connect_object(GTK_OBJECT(button),
                           "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy),
                           GTK_OBJECT(list_window));

 gtk_widget_show(list_window);
 gtk_grab_add(list_window);
 gtk_main();
}

static void list_main_click(GtkWidget *from, sticky_note *data)
{
 internal_list_main_click(from, data, FALSE);
}

static void list_hidden_main_click(GtkWidget *from, sticky_note *data)
{
 internal_list_main_click(from, data, TRUE);
}

#ifndef NDEBUG
static void editable_note_toggle(GtkWidget *from, sticky_note *data)
{
 IGNORE_PARAMETER(from);
 
 gtk_text_set_editable(GTK_TEXT(data->text),
                       !GTK_EDITABLE(data->text)->editable);
}
#endif

static void changed_text_press(GtkWidget *from, sticky_note *note)
{
 IGNORE_PARAMETER(from);

 gtk_widget_set_sensitive(save_all_item, TRUE);
 gtk_widget_set_sensitive(note->save_menu_item, TRUE);
}

static int internal_save_all_stickies(sticky_note *note, va_list va)
{
 IGNORE_PARAMETER(&va);
 
 if (GTK_WIDGET_IS_SENSITIVE(note->save_menu_item) ||
     changed_position_size(note->window,
                           note->x_pos, note->y_pos,
                           note->x_size, note->y_size))
   save_note_click(NULL, note);
 
 return (TRUE);
}

static void save_all_stickies(GtkWidget *from, gpointer nothing)
{
 IGNORE_PARAMETER(from && nothing);

 write_preferences_file();

 set_save_all_sensitive();
 
 if (GTK_WIDGET_IS_SENSITIVE(save_all_item))
   sticky_note_do_inorder(internal_save_all_stickies, &base);
}

static void save_one_finnish_quit_event(GtkWidget *from,
                                        gpointer real_params)
{
 sticky_note *note = real_params;

 if (GTK_WIDGET_IS_SENSITIVE(note->save_menu_item) ||
     changed_position_size(note->window,
                           note->x_pos, note->y_pos,
                           note->x_size, note->y_size))
   save_note_click(NULL, note);
 
 gtk_widget_destroy(from);
}

static void save_all_finnish_quit_event(GtkWidget *from, gpointer nothing)
{
 IGNORE_PARAMETER(nothing);

 save_all_stickies(NULL, NULL);
 
 gtk_widget_destroy(from);
}

static void query_save_stickies(GtkWidget *from, sticky_note *note)
{
 GtkWidget *window = NULL;
 GtkWidget *vbox = NULL;
 GtkWidget *hbox = NULL;
 GtkWidget *label = NULL;
 GtkWidget *button = NULL;
 
 IGNORE_PARAMETER(from);

 window = gtk_window_new(prefs.extra_win_type);
 gtk_window_position(GTK_WINDOW(window), prefs.win_pos_type);

 gtk_window_set_wmclass(GTK_WINDOW(window), "saved_ask", "gtk_note");
 gtk_widget_set_uposition(window, -1, -1);
 gtk_window_set_policy(GTK_WINDOW(window), TRUE, TRUE, TRUE);
 gtk_window_set_title(GTK_WINDOW(window), "Query save");
 gtk_signal_connect(GTK_OBJECT(window),
                    "destroy", GTK_SIGNAL_FUNC(on_finish_event), NULL);
 
 vbox = gtk_vbox_new(FALSE, 5);
 gtk_container_border_width(GTK_CONTAINER(vbox), 5);
 gtk_container_add(GTK_CONTAINER(window), vbox);
 gtk_widget_show(vbox);
 
 label = gtk_label_new(" Do you want to save all your unsaved notes ?");
 gtk_box_pack_start(GTK_BOX(vbox), label, TRUE, TRUE, 0);
 gtk_widget_show(label);
 
 hbox = gtk_hbox_new(FALSE, 5);
 gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, TRUE, 0);
 gtk_widget_show(hbox);

 button = gtk_button_new_with_label("Yes");
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
 GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);
 gtk_widget_grab_default(button);
 gtk_widget_show(button);
 gtk_signal_connect(GTK_OBJECT(button),
                    "clicked", GTK_SIGNAL_FUNC(save_all_finnish_quit_event),
                    NULL);
 gtk_signal_connect_object(GTK_OBJECT(button),
                           "destroy", GTK_SIGNAL_FUNC(gtk_widget_destroy),
                           GTK_OBJECT(window));
 button = gtk_button_new_with_label("No");
 gtk_widget_show(button);
 gtk_signal_connect_object(GTK_OBJECT(button),
                           "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy),
                           GTK_OBJECT(window));
 gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);

 if (note) /* done from a note */
 {
  char buffer[90];

  if (strnlen(note->name, 80) == 80)
  {
   sprintf(buffer, "Save: %.80s...", note->name);
   button = gtk_button_new_with_label(buffer);
  }
  else
  {
   sprintf(buffer, "Save: %s", note->name);
   button = gtk_button_new_with_label(buffer);
  }
  
  gtk_widget_show(button);
  gtk_signal_connect(GTK_OBJECT(button),
                     "clicked", GTK_SIGNAL_FUNC(save_one_finnish_quit_event),
                     note);
  gtk_signal_connect_object(GTK_OBJECT(button),
                            "destroy", GTK_SIGNAL_FUNC(gtk_widget_destroy),
                           GTK_OBJECT(window));
  gtk_box_pack_start(GTK_BOX(vbox), button, TRUE, TRUE, 0);
 }

 gtk_widget_show(window);
 gtk_grab_add(window);
 gtk_main();
}

static void quit_program_click(GtkWidget *from, sticky_note *note)
{
 /* FIXME: should just be able to say...
  *   if (GTK_WIDGET_IS_SENSITIVE(save_all_item)) ...
  * but it doens't work as we don't know when some things have changed
  */
 set_save_all_sensitive();
 
 if (GTK_WIDGET_IS_SENSITIVE(save_all_item))
   switch (prefs.action_on_quit)
   {
    default:
      assert(FALSE);
    break;
    
    case STICKY_MASTER_QUIT_SAVE:
      save_all_stickies(NULL, NULL);
      break;
    case STICKY_MASTER_QUIT_ASK:
      query_save_stickies(from, note);
      break;
      
    case STICKY_MASTER_QUIT_QUIT:
      break;
   }
 
 gtk_main_quit();
}

static void setup_notes_menus(GtkWindow *window, GtkBox *box,
                              sticky_note *note)
{
 GtkWidget *menu_bar = NULL;
 GtkAccelGroup *table = gtk_accel_group_new();
 GtkWidget *menu = NULL;
 GtkWidget *file_menu = NULL;
 GtkWidget *edit_menu = NULL;
 GtkWidget *note_menu = NULL;
 GtkWidget *help_menu = NULL;
 
 menu_helper file_menu_input[] =
 {
  {"New", GTK_SIGNAL_FUNC(new_main_click), NULL, "<control>-N"},
  MENU_HELPER_SEPARATOR(),
  {"Preferences...", GTK_SIGNAL_FUNC(preferences_note_click), note, "<control>-P"},
  MENU_HELPER_SEPARATOR(),
  {"Quit", GTK_SIGNAL_FUNC(quit_program_click), note, "<control>-Q"},
  MENU_HELPER_END(),
 };
 menu_helper edit_menu_input[] =
 {
#if 0
  /* not sure how to do this yet ... */
  {"Undo", GTK_SIGNAL_FUNC(undo_note_click), note},
  MENU_HELPER_SEPARATOR(),
#endif
  {"Cut", GTK_SIGNAL_FUNC(cut_note_click), note, "<control>-X"},
  {"Copy", GTK_SIGNAL_FUNC(copy_note_click), note, "<control>-C"},
  MENU_HELPER_SEPARATOR(),
  {"Paste", GTK_SIGNAL_FUNC(paste_note_click), note, "<control>-V"},
  MENU_HELPER_END(),
 };
 menu_helper note_menu_input[] =
 {
#ifndef NDEBUG
  {"tmp", GTK_SIGNAL_FUNC(tmp_print), note},
#endif
  {"Hide", GTK_SIGNAL_FUNC(hide_note_toggle), note, "<control>-W"},
  {"Erase", GTK_SIGNAL_FUNC(erase_note_click), note, "<alt>-W"},
  MENU_HELPER_SEPARATOR(),
  {"Destroy", GTK_SIGNAL_FUNC(destroy_note_click), note, "<control>-<alt>-W"},
#ifndef NDEBUG
  MENU_HELPER_SEPARATOR(),
  {"Editable", GTK_SIGNAL_FUNC(editable_note_toggle), note},
#endif
  MENU_HELPER_END(),
 };
 menu_helper help_menu_input[] =
 {
  {"About...", GTK_SIGNAL_FUNC(about_note_click), note},
  MENU_HELPER_END(),
 };
 
 file_menu = gtk_menu_item_new_with_label("File");
 gtk_widget_show(file_menu);

 menu = gtk_menu_new();
 note->save_menu_item = gtk_menu_item_new_with_label("Save");
 gtk_widget_set_sensitive(note->save_menu_item, FALSE);
 gtk_widget_add_accelerator(note->save_menu_item, "activate", table,
                            'S', GDK_CONTROL_MASK, 0);
 gtk_menu_append(GTK_MENU(menu), note->save_menu_item);
 gtk_signal_connect(GTK_OBJECT(note->save_menu_item), "activate",
                    GTK_SIGNAL_FUNC(save_note_click), note);
 gtk_widget_show(note->save_menu_item);
 
 gtk_menu_item_set_submenu(GTK_MENU_ITEM(file_menu),
                           menu_helper_add(menu, &table, file_menu_input)); 
 
 edit_menu = gtk_menu_item_new_with_label("Edit");
 gtk_widget_show(edit_menu);
 gtk_menu_item_set_submenu(GTK_MENU_ITEM(edit_menu),
                           menu_helper_add(gtk_menu_new(),
                                           &table, edit_menu_input)); 
 
 note_menu = gtk_menu_item_new_with_label("Note");
 gtk_widget_show(note_menu);
 gtk_menu_item_set_submenu(GTK_MENU_ITEM(note_menu),
                           menu_helper_add(gtk_menu_new(),
                                           &table, note_menu_input)); 

 help_menu = gtk_menu_item_new_with_label("Help");
 gtk_menu_item_right_justify(GTK_MENU_ITEM(help_menu));
 gtk_widget_show(help_menu);
 gtk_menu_item_set_submenu(GTK_MENU_ITEM(help_menu),
                           menu_helper_add(gtk_menu_new(),
                                           NULL, help_menu_input)); 
 gtk_window_add_accel_group(window, table);
 
 menu_bar = gtk_menu_bar_new();
 gtk_box_pack_start(GTK_BOX(box), menu_bar, FALSE, FALSE, 0);
 
 gtk_menu_bar_append(GTK_MENU_BAR(menu_bar), file_menu);
 gtk_menu_bar_append(GTK_MENU_BAR(menu_bar), edit_menu);
 gtk_menu_bar_append(GTK_MENU_BAR(menu_bar), note_menu);

 gtk_menu_bar_append(GTK_MENU_BAR(menu_bar), help_menu);
 
 gtk_widget_show(menu_bar);
}

static void sticky_note_cleanup(GtkWidget *from, sticky_note *note)
{
 IGNORE_PARAMETER(from);

 sticky_note_del(note);
 sticky_note_destroy(note);
}

int sticky_note_create(sticky_note *note)
{
 GtkWidget *window = NULL;
 GtkWidget *vbox = NULL;
 GtkWidget *hbox = NULL;
 GtkWidget *vscrollbar = NULL;
 GtkWidget *text = NULL;
 char *text_data = NULL;
 size_t nchars = 0;
 int using_scrollbar = TRUE;
 int hidden = FALSE;
 file_io fs;
 
 if (!(note->window = window = gtk_window_new(prefs.note_win_type)))
   return (FALSE);

 if (note->filename)
   if (file_read_open(note->filename, &fs))
   {
    file_section_beg("options", &fs);

    note->auto_placement = file_get_bitflag("auto_placment", &fs);
    hidden = file_get_bitflag("hidden", &fs);
    
    note->name = file_get_malloc("name", NULL, &fs);
    assert(note->name);
    
    note->unique_id = file_get_unsigned_int("unique_id", &fs);
    
    note->using_right = file_get_bitflag("using_right", &fs);
    using_scrollbar = file_get_bitflag("using_scrollbar", &fs);

    note->word_wrap = file_get_bitflag("word_wrap", &fs);

    note->x_pos = file_get_int("x_position", &fs);
    note->x_size = file_get_int("x_size", &fs);
    note->y_pos = file_get_int("y_position", &fs);
    note->y_size = file_get_int("y_size", &fs);
    
    file_section_end(&fs);
    
    if (!(text_data = file_get_malloc("text", &nchars, &fs)))
    {
     free(note->filename);
     free(note);
     
     return (FALSE);
    }
    
    file_read_close(&fs);
   }
   else
   {
    free(note->filename);
    free(note);
    return (FALSE);
   }
 
 gtk_window_set_wmclass(GTK_WINDOW(window), "note", "gtk_note");
 if (note->auto_placement)
   gtk_widget_set_uposition(window, -1, -1);
 else
   gtk_widget_set_uposition(window, note->x_pos, note->y_pos);
 if ((note->x_size < 120) || (note->y_size < 120))
   gtk_widget_set_usize(window, 250, 200); /* default size */
 else
   gtk_widget_set_usize(window, note->x_size, note->y_size);
 gtk_window_set_policy(GTK_WINDOW(window), TRUE, TRUE, TRUE); 
 gtk_window_set_title(GTK_WINDOW(window), note->name);
 gtk_signal_connect(GTK_OBJECT(window), "destroy",
                    GTK_SIGNAL_FUNC(sticky_note_cleanup), note);
 gtk_signal_connect(GTK_OBJECT(window), "delete_event",
                    GTK_SIGNAL_FUNC(gtk_widget_hide_on_delete), NULL);
#ifdef USE_MOVE_RESIZE_SIGNAL
 gtk_signal_connect(GTK_OBJECT(window), "move_resize",
                    GTK_SIGNAL_FUNC(sticky_note_store_move_resize), note);
#endif
 gtk_container_border_width(GTK_CONTAINER(window), 0);
  
 vbox = gtk_vbox_new(FALSE, 0);
 gtk_container_add(GTK_CONTAINER(window), vbox);
 gtk_container_border_width(GTK_CONTAINER(vbox), 0);
 gtk_widget_show(vbox);

 setup_notes_menus(GTK_WINDOW(window), GTK_BOX(vbox), note);
 
 note->hbox = hbox = gtk_hbox_new(FALSE, 0);
 gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);
 gtk_widget_show(hbox);
  
 note->text = text = gtk_text_new(NULL, NULL);
 gtk_text_set_editable(GTK_TEXT(text), TRUE);
 gtk_box_pack_start(GTK_BOX(hbox), text, TRUE, TRUE, 0);
 gtk_signal_connect(GTK_OBJECT(text), "changed",
                    GTK_SIGNAL_FUNC(changed_text_press), note); 
 gtk_widget_show(text);
 
 vscrollbar = gtk_vscrollbar_new(GTK_TEXT(text)->vadj);
 gtk_box_pack_start(GTK_BOX(hbox), vscrollbar, FALSE, FALSE, 0);
 gtk_widget_show(vscrollbar);
 note->vscrollbar = vscrollbar;

#if 0
 /* FIXME: widget doesn't work with horiz scrollbar yet. */
 hscrollbar = gtk_hscrollbar_new(GTK_TEXT(text)->hadj);
 gtk_box_pack_start(GTK_BOX(vbox), hscrollbar, TRUE, TRUE, 0);
 gtk_widget_show(hscrollbar);
#endif
 
 gtk_widget_realize(text);
 
 if (!note->using_right)
   gtk_box_reorder_child(GTK_BOX(hbox), vscrollbar, 0);
 
 if (!using_scrollbar)
   gtk_widget_hide(note->vscrollbar);

 if (nchars && text_data)
 {
  gtk_text_freeze(GTK_TEXT(note->text));
  
  gtk_text_insert(GTK_TEXT(text), NULL, NULL, NULL, text_data, nchars);
  
  gtk_text_thaw(GTK_TEXT(note->text));
 }

 if (hidden)
   gtk_widget_realize(window);
 else
   gtk_widget_show(window);

 return (TRUE);
}

void sticky_note_destroy(sticky_note *note)
{
 assert(note);

 free((void *) note->filename);
 free((void *) note->name);
 free(note);
}

static int internal_hide_all_stickies(sticky_note *note, va_list va)
{
 IGNORE_PARAMETER(&va);

 if (GTK_WIDGET_VISIBLE(note->window))
   gtk_widget_hide(note->window);
 
 return (TRUE);
}

static void hide_all_stickies(GtkWidget *from, gpointer nothing)
{
 IGNORE_PARAMETER(from && nothing);

 sticky_note_do_inorder(internal_hide_all_stickies, &base);
}

static int internal_show_all_stickies(sticky_note *note, va_list va)
{
 IGNORE_PARAMETER(&va);

 if (!GTK_WIDGET_VISIBLE(note->window))
   gtk_widget_show(note->window);
 
 return (TRUE);
}

static void show_all_stickies(GtkWidget *from, gpointer nothing)
{
 IGNORE_PARAMETER(from && nothing);

 sticky_note_do_inorder(internal_show_all_stickies, &base);
}

static int internal_raise_all_stickies(sticky_note *note, va_list va)
{
 IGNORE_PARAMETER(&va);

 gdk_window_raise(note->window->window);
 
 return (TRUE);
}

static void raise_all_stickies(GtkWidget *from, gpointer nothing)
{
 IGNORE_PARAMETER(from && nothing);

 sticky_note_do_inorder(internal_raise_all_stickies, &base);
}

static int internal_lower_all_stickies(sticky_note *note, va_list va)
{
 IGNORE_PARAMETER(&va);

 gdk_window_lower(note->window->window);
 
 return (TRUE);
}

static void lower_all_stickies(GtkWidget *from, gpointer nothing)
{
 IGNORE_PARAMETER(from && nothing);

 sticky_note_do_inorder(internal_lower_all_stickies, &base);
}

static int main_clicked_event(GtkWidget *from, GdkEventButton *event,
                              GtkWidget *menu)
{
 IGNORE_PARAMETER(from);

 switch (event->type)
 {
  case GDK_BUTTON_PRESS:
    /* normal */
    break;
    
  case GDK_2BUTTON_PRESS:
    /* double click */
  case GDK_3BUTTON_PRESS:
    /* triple click */
    return (FALSE);
    
  default:
    printf("%d\n", event->type);
    assert(FALSE);
 }

 switch (event->button)
 {
  case 1:
  case 2:
    switch ((event->button == 1) ?
            prefs.mouse_one_action : prefs.mouse_two_action)
    {
     case STICKY_MASTER_BUTTON_RAISE:
       raise_all_stickies(NULL, NULL);
       return (TRUE);
     case STICKY_MASTER_BUTTON_LOWER:
       lower_all_stickies(NULL, NULL);
       return (TRUE);
     case STICKY_MASTER_BUTTON_SHOW:
       show_all_stickies(NULL, NULL);
       return (TRUE);
     case STICKY_MASTER_BUTTON_HIDE:
       hide_all_stickies(NULL, NULL);
       return (TRUE);

     default:
       assert(FALSE);
    }
    return (FALSE);

  case 3: /* menu */
    /* FIXME: hack until I can find out when things have moved/resized */
    set_save_all_sensitive();
    
    gtk_menu_popup(GTK_MENU(menu), NULL, NULL, NULL, NULL,
                   event->button, event->time);
    return (TRUE);

  case 4: /* X definatly supports upto 5 buttons */
  case 5:
    break;
    
  default:
    /* does X support this ? */
    assert(FALSE);
 }
 
 return (FALSE);
}

static void quit_main_click(GtkWidget *from, gpointer nothing)
{
 IGNORE_PARAMETER(from && nothing);

 gtk_widget_destroy(main_window);
}

static void init_one_sticky(unsigned int number)
{
 sticky_note *note = malloc(sizeof(sticky_note));

 note->unique_id = number;

 sticky_init_filename(note);

 if (!sticky_note_create(note))
   return;

 assert(note->unique_id == number);
 
 sticky_note_add(&base, note);
}

static void init_all_stickies(void)
{
 struct stat buf;

 if (!stat("index", &buf) && S_ISREG(buf.st_mode))
 {
  file_io fs;

  if (file_read_open("index", &fs))
  {
   int total_count = file_get_int("count", &fs);
   int count = 0;
   
   file_section_beg("data", &fs);
   
   while (count < total_count)
   {
    char count_buffer[64];
    int unique_id = 0;
    
    sprintf(count_buffer, "%04d", ++count);

    unique_id = file_get_unsigned_int(count_buffer, &fs);
    
    init_one_sticky(unique_id);
   }
   assert(count == total_count);

   file_section_end(&fs);
   
   file_read_close(&fs);
  }
 }
 else
   write_index_file();
}

static void internal_com_fd_destroy(gpointer real_data)
{
 com_struct *coms = real_data;

 shutdown(coms->source, 0);
 close(coms->source);
}

static void internal_com_fd_read(gpointer real_data, int source,
                                 GdkInputCondition condition)
{
 com_struct *coms = real_data;
 sticky_note *note = NULL;
 ssize_t read_data = 0;
 int done = FALSE;
 
 IGNORE_PARAMETER(condition);
 
 if (!coms)
   return;

 assert(coms->source == source);
 
 if (!coms->done_header)
 {
  if ((1024 - coms->read_data) >= 1)
  {
   read_data = read(source, coms->buffer + coms->read_data,
                    1024 - coms->read_data);
   if (read_data != -1)
     coms->read_data += (size_t) read_data;
  }
  
  if (coms->read_data >= 1024)
    gtk_input_remove(coms->gtk_input_id);
  else
    if (coms->buffer[coms->read_data - 1] != '\n')
      return;
  
  if ((coms->read_data > CONST_STRLEN("new_note")) &&
      !strncmp("new_note", coms->buffer, CONST_STRLEN("new_note")))
  {
   char buffer[64 + CONST_STRLEN("Note ")];
   
   note = g_malloc(sizeof(sticky_note));
   
   coms->unique_id = note->unique_id = sticky_get_new_unique();
   g_snprintf(buffer, 80, "Note %d", note->unique_id);
   note->name = g_strdup(buffer);
   note->x_size = 250;
   note->y_size = 200;
   note->x_pos = -1;
   note->y_pos = -1;
   
   sticky_note_init(note); 
   
   sticky_note_create(note);
   
   sticky_init_filename(note);
   
   sticky_note_add(&base, note);
   
   gtk_widget_show(note->window);
   
   write_index_file();
   save_note_click(NULL, note);
  }
  else if ((((size_t) coms->read_data) > CONST_STRLEN("note_name:")) &&
           !strncmp("note_name:", coms->buffer, CONST_STRLEN("note_name:")))
  {
   assert(coms->buffer[coms->read_data - 1] == '\n');
   coms->buffer[coms->read_data - 1] = 0;
   
   note = sticky_note_casename_find(&base,
                                    coms->buffer + CONST_STRLEN("note_name:"));
   if (note)
     coms->unique_id = note->unique_id;
   else
   {
    while (write(source, "\000", 1) != 1) { /* loop */ }
    return;
   }
  }
  else
  {
   while (write(source, "\000", 1) != 1) { /* loop */ }
   return;
  }
    
  coms->done_header = TRUE;
  coms->read_data = 0;
  
  /* we _have_ to be able to write one char down the socket */
  
  while (write(source, "\001", 1) != 1) { /* loop */ }
  
  return;
 }

 assert(!coms->read_data);
 
 if (!(note = sticky_note_id_find(&base, coms->unique_id)))
   gtk_input_remove(coms->gtk_input_id);

 read_data = read(source, coms->buffer, 1024);
 while ((read_data != 0) && (read_data != -1))
 {
  if (!done)
    gtk_text_freeze(GTK_TEXT(note->text));

  done = TRUE;
  
  gtk_text_insert(GTK_TEXT(note->text), NULL, NULL, NULL,
                  coms->buffer, read_data);

  read_data = read(source, coms->buffer, 1024);
 }

 if (done)
 {
  gtk_text_thaw(GTK_TEXT(note->text));
  if (read_data == -1)
    gtk_input_remove(coms->gtk_input_id);
 }
 else
   gtk_input_remove(coms->gtk_input_id);
 
}

static void internal_sock_fd_accept(gpointer data, int source,
                                    GdkInputCondition condition)
{
 int length = sizeof(sa);
 int new_com = 0;
  /* gets removed by list auto */
 com_struct *tmp = g_malloc(sizeof(com_struct));
 
 IGNORE_PARAMETER(condition && data);

 if (!tmp)
   return;
 
 if ((new_com = accept(source, (struct sockaddr *)&sa, &length)) == -1)
 {
  g_free(tmp);
  return;
 }

 tmp->done_header = FALSE;
 tmp->read_data = 0;
 tmp->source = new_com;
 
 tmp->gtk_input_id = gtk_input_add_full(new_com, GDK_INPUT_READ,
                                        internal_com_fd_read,
                                        NULL, tmp,
                                        internal_com_fd_destroy);
}

static void create_main_socket(void)
{
 remove("coms");
 
 if ((sock_fd = socket(AF_UNIX, SOCK_STREAM, 0)) == -1)
   return; 
 
 sa.sun_family = AF_UNIX;
 strcpy(sa.sun_path, "coms");

 if (fcntl(sock_fd, F_SETFL, O_NONBLOCK) < 0)
 {
  fprintf(stderr, " Can't set non-blocking on coms socket, killing it.\n");
  close(sock_fd);
  sock_fd = -1;
  return;  
 }
 
 if (bind(sock_fd, (struct sockaddr *)&sa, sizeof(sa)) == -1)
 {
  fprintf(stderr, " Can't bind to coms socket, killing it.\n");
  close(sock_fd);
  sock_fd = -1;
  return;
 }

 if (listen(sock_fd, 10) == -1)
 {
  fprintf(stderr, " Can't listen on coms socket, killing it.\n");
  close(sock_fd);
  sock_fd = -1;
  return;
 }

 gtk_input_add_full(sock_fd, GDK_INPUT_READ, internal_sock_fd_accept,
                    NULL, NULL, NULL);
}

static void create_main_window(void)
{
 GtkAccelGroup *table = gtk_accel_group_new();
 GtkWidget *button = NULL;
 GtkWidget *pixmapwid = NULL;
 GdkPixmap *pixmap = NULL;
 GdkBitmap *mask = NULL;
 GtkStyle *style = NULL;
 GtkWidget *menu = NULL;
 
 menu_helper main_menu_input_start[] =
 {
  {"New", GTK_SIGNAL_FUNC(new_main_click), NULL, "<control>-N"},
  MENU_HELPER_SEPARATOR(),
  {"Preferences...", GTK_SIGNAL_FUNC(preferences_main_click), NULL, "<control>-P"},
  MENU_HELPER_END(),
 };

 menu_helper main_menu_input_end[] =
 {
  MENU_HELPER_SEPARATOR(),
  {"List all notes", GTK_SIGNAL_FUNC(list_main_click), NULL, "<control>-L"},
  {"List hidden notes", GTK_SIGNAL_FUNC(list_hidden_main_click)},
  MENU_HELPER_SEPARATOR(),
  {"Raise all notes", GTK_SIGNAL_FUNC(raise_all_stickies), NULL},
  {"Lower all notes", GTK_SIGNAL_FUNC(lower_all_stickies), NULL},
  {"Show all notes", GTK_SIGNAL_FUNC(show_all_stickies), NULL},
  {"Hide all notes", GTK_SIGNAL_FUNC(hide_all_stickies), NULL},  
  MENU_HELPER_SEPARATOR(),
  {"Quit", GTK_SIGNAL_FUNC(quit_main_click), NULL, "<control>-Q"},
  MENU_HELPER_END(),
 };

 if (!(main_window = gtk_window_new(prefs.master_win_type)))
 {
  printf(" Couldn't open main window.\n");
  exit (EXIT_FAILURE);
 }

 gtk_window_set_wmclass(GTK_WINDOW(main_window), "master", "gtk_note");

 read_preferences_file();
 
 gtk_window_set_policy(GTK_WINDOW(main_window), TRUE, TRUE, TRUE);
 gtk_container_border_width(GTK_CONTAINER(main_window), 0);
 gtk_signal_connect(GTK_OBJECT(main_window), "destroy",
                    GTK_SIGNAL_FUNC(quit_program_click), NULL);
 gtk_widget_realize(main_window);
 
 gtk_window_set_title(GTK_WINDOW(main_window), "Main");

 style = gtk_widget_get_style(main_window);
 pixmap = gdk_pixmap_create_from_xpm_d(main_window->window, &mask,
                                       &style->bg[GTK_STATE_NORMAL],
                                       (char **)xpm_data);
 pixmapwid = gtk_pixmap_new(pixmap, mask);

 gtk_widget_show(pixmapwid); 
 
 button = gtk_button_new();
 gtk_container_add(GTK_CONTAINER(button), pixmapwid);
 gtk_container_add(GTK_CONTAINER(main_window), button);

 menu = gtk_menu_new();
 menu_helper_add(menu, &table, main_menu_input_start);
 
 save_all_item = gtk_menu_item_new_with_label("Save all stickies");
 gtk_widget_set_sensitive(save_all_item, FALSE);
 gtk_widget_add_accelerator(save_all_item, "activate", table, 
                            'S', GDK_CONTROL_MASK, 0);
 gtk_menu_append(GTK_MENU(menu), save_all_item);
 gtk_signal_connect(GTK_OBJECT(save_all_item), "activate",
                    GTK_SIGNAL_FUNC(save_all_stickies), NULL);
 gtk_widget_show(save_all_item);

 menu_helper_add(menu, &table, main_menu_input_end);
 
 gtk_signal_connect(GTK_OBJECT(button), "button_press_event",
                    GTK_SIGNAL_FUNC(main_clicked_event),
                    GTK_OBJECT(menu));
 gtk_window_add_accel_group(GTK_WINDOW(main_window), table);
 gtk_widget_show(button);

 gtk_widget_show(main_window);

 create_main_socket();
}

static void init_rcs(void)
{
 struct stat buf;

 if (!stat("gtkrc", &buf) && S_ISREG(buf.st_mode))
   gtk_rc_parse("gtkrc");
 else
   gtk_rc_parse(STICKY_NOTES_SYSTEM_RC);
}

#ifndef USE_GNOME
static void init_cmd_line_options(int argc, char *argv[])
{
 const char *specified_note_dir = NULL;
 struct option long_options[] =
 {
  {"sticky-dir", required_argument, NULL, 'd'},
  {"window-offset", required_argument, NULL, 1},
  {"window-x-offset", required_argument, NULL, 2},
  {"window-y-offset", required_argument, NULL, 3},
  {"help", no_argument, NULL, 'h'},
  {"version", no_argument, NULL, 'v'},  
  {NULL, 0, NULL, 0}
 };
 const char *program_name = argv[0];
 int optchar = 0;
 
 if ((program_name = strrchr(argv[0], '/')))
   ++program_name;
 else
   program_name = argv[0];
 
 while ((optchar = getopt_long(argc, argv, "HhVvd:", long_options, NULL))
        != EOF)
   switch (optchar)
   {
    case '?':
      fprintf(stderr, "%s", " Unknown option...\n");
    case 'H':
    case 'h':
      fprintf(stderr, " Usage: %s [-dhv]\n%s", program_name,
              " --sticky-dir -d        - Change the base directory.\n"
              " --window-offset        - Used to hack the placements of windows.\n"
              " --help -h              - Print this message.\n"
              " --version -v           - Print the version.\n");
      exit (optchar == 'h' ? EXIT_SUCCESS : EXIT_FAILURE);

    case 'V':
    case 'v':
      printf("%s", " Version: 0.8 of sticky-notes, by James Antill\n");
      exit (EXIT_SUCCESS);

    case 'd':
      specified_note_dir = optarg;
      break;

    case 1:
      sticky_win_y_offset = sticky_win_x_offset = atoi(optarg);
      break;
    case 2:
      sticky_win_x_offset = atoi(optarg);
      break;
    case 3:
      sticky_win_y_offset = atoi(optarg);
      break;
      
    default:
      assert(FALSE);
   }

 if (specified_note_dir)
 {
  if (chdir(specified_note_dir))
  {
   mkdir(specified_note_dir, 0700);
   if (chdir(specified_note_dir))
   {
    fprintf(stderr, " Could not cd to (or create) specified directory.\n");
    exit (EXIT_FAILURE);
   }
  }
 }
 else
 {
  if (chdir(getenv("HOME")))
  {
   fprintf(stderr, " Could not cd to home directory.\n");
   exit (EXIT_FAILURE);
  }
  
  if (chdir(".sticky"))
  {
   mkdir(".sticky", 0700);
   if (chdir(".sticky"))
   {
    fprintf(stderr, " Could not cd to (or create) .sticky directory in "
            "your home directory.\n");
    exit (EXIT_FAILURE);
   }
  }
 }
}
#endif

static void init_signals(void)
{
 struct sigaction sa;

 sigemptyset(&sa.sa_mask);
 
 sa.sa_flags = SA_RESTART; /* restart a system call if it interupts */
 sa.sa_handler = SIG_IGN; /* ignore it... we don't have a use for it */

 sigaction(SIGUSR1, &sa, NULL);
 sigaction(SIGUSR2, &sa, NULL);
 sigaction(SIGALRM, &sa, NULL);

 sa.sa_flags = SA_NOCLDSTOP;               sigaction(SIGCHLD, &sa, NULL);

 sa.sa_flags = 0; /* don't restart... */

 sigaction(SIGPIPE, &sa, NULL);
}

int main(int argc, char *argv[])
{
#ifdef USE_GNOME
 sticky_gnome_main(argc, argv);
#else
 gtk_set_locale();
 
 gtk_init(&argc, &argv);

 init_cmd_line_options(argc, argv);
#endif

 init_signals();
 
 init_rcs();
 
 create_main_window();

 assert(main_window);
 
 init_all_stickies();
 
 gtk_main();

 exit (EXIT_SUCCESS);
}
